Magellan Linux

Annotation of /trunk/magellan-initscripts/etc/rc.d/init.d/rc

Parent Directory Parent Directory | Revision Log Revision Log


Revision 431 - (hide annotations) (download)
Tue Mar 6 00:10:26 2007 UTC (17 years, 2 months ago) by niro
File size: 9897 byte(s)
fixed udev version detection and support RC_COLDPLUG

1 niro 2 #!/bin/bash
2 niro 431 # $Header: /home/cvsd/magellan-cvs/magellan-src/magellan-initscripts/etc/rc.d/init.d/rc,v 1.14 2007-03-06 00:10:26 niro Exp $
3 niro 2
4     source /etc/sysconfig/rc
5     source $rc_functions
6    
7 niro 50 # get mage version
8     MAGEVER="$(< /etc/mageversion)"
9 niro 2
10 niro 150 # source kernel config if exists
11 niro 2 [ -f /etc/conf.d/kernel ] && source /etc/conf.d/kernel
12    
13 niro 319 udev_version()
14     {
15     local version=0
16    
17     if [[ -x /sbin/udev ]]
18     then
19     version=$(/sbin/udev -V)
20     # We need it without a leading '0', else bash do the wrong thing
21     version=${version##0}
22     # Older udev's will print nothing
23     [[ -z ${version} ]] && version=0
24 niro 431 elif [[ -x /sbin/udevd ]]
25     then
26     version=$(/sbin/udevd --version)
27     version=${version##0}
28     [[ -z ${version} ]] && version=0
29 niro 319 fi
30    
31     echo "${version}"
32     }
33    
34     populate_udev()
35     {
36 niro 394 local opts
37 niro 318
38 niro 428 # tell modprobe.sh to be verbose to $CONSOLE
39     echo CONSOLE=${CONSOLE} > /dev/.udev_populate
40    
41 niro 318 # populate /dev with devices already found by the kernel
42 niro 376 if [ "$(kernel_version | sed 's:\.::g' | cut -d_ -f1)" -gt "2614" ]
43 niro 318 then
44     echo -e ${COLOREDSTAR}" Populating /dev with existing devices through uevents ..."
45 niro 431 [[ $(udev_version) -ge "96" ]] && [[ ${RC_COLDPLUG} != yes ]] && opts="--attr-match=dev"
46 niro 394 /sbin/udevtrigger ${opts}
47 niro 318 evaluate_retval
48     else
49     echo -e ${COLOREDSTAR}" Populating /dev with existing devices with udevstart ..."
50 niro 2 /sbin/udevstart
51 niro 318 evaluate_retval
52     fi
53 niro 2
54 niro 318 # loop until everything is finished
55     echo -e ${COLOREDSTAR}" Letting udev process events ..."
56 niro 394 /sbin/udevsettle --timeout=60
57 niro 318 evaluate_retval
58    
59 niro 428 rm -f /dev/.udev_populate
60 niro 318 return 0
61     }
62    
63 niro 319 seed_dev()
64     {
65 niro 318 # seed /dev with some things that we know we need
66     echo -e ${COLOREDSTAR}" Seeding /dev with needed nodes ..."
67     (
68 niro 428 [ ! -c /dev/console ] && mknod /dev/console c 5 1
69     [ ! -c /dev/tty1 ] && mknod /dev/tty1 c 4 1
70     [ ! -c /dev/null ] && mknod /dev/null c 1 3
71    
72 niro 318 # copy over any persistant things
73 niro 394 if [[ -d /lib/udev/devices ]]
74     then
75     cp --preserve=all --recursive --update /lib/udev/devices/* /dev
76     fi
77 niro 428
78 niro 150 # not provided by sysfs but needed
79 niro 2 ln -snf /proc/self/fd /dev/fd
80     ln -snf fd/0 /dev/stdin
81     ln -snf fd/1 /dev/stdout
82     ln -snf fd/2 /dev/stderr
83 niro 318 [[ -e /proc/kcore ]] && ln -snf /proc/kcore /dev/core
84    
85 niro 150 # create problematic directories
86 niro 2 mkdir -p /dev/{pts,shm}
87 niro 318 )
88     evaluate_retval
89     }
90 niro 2
91     trap "" INT QUIT TSTP
92    
93     [ "$1" != "" ] && runlevel=$1
94    
95 niro 150 if [[ $runlevel = sysinit ]]
96 niro 2 then
97     echo
98     echo -e "${COLGREEN}Starting ${COLBLUE}MAGELLAN (v${MAGEVER}) ${COLGREEN}Linux${COLDEFAULT}"
99 niro 425 echo -e "Copyright 2001-2007 Niels Rogalla; http://magellan-linux.net"
100 niro 2 echo
101    
102 niro 150 # mount proc filesystem, needed for bootsplash;
103     # no use of '/etc/rc.d/init.d/mountproc' anymore
104 niro 2 if [ ! -e /proc/mounts ]
105     then
106     echo -e ${COLOREDSTAR}"Mounting proc file system ..."
107     mount -n /proc
108     evaluate_retval
109     fi
110    
111 niro 150 # set default verbose level for kernel messages
112 niro 2 [ -z "${RC_VERBOSE_LEVEL}" ] && RC_VERBOSE_LEVEL=3
113     echo "${RC_VERBOSE_LEVEL}" > /proc/sys/kernel/printk
114    
115 niro 150 # mount sys file system before udev or devfs (kernel-2.6)
116     if [[ $(kernel_major_version) = 2.6 ]]
117 niro 2 then
118     if [ -d /sys ]
119     then
120     echo -e ${COLOREDSTAR}"Mounting sysfs file system ..."
121 niro 150 mount -n -t sysfs sysfs /sys
122 niro 2 evaluate_retval
123     else
124     echo -e ${COLORED}"Fatal: mountpoint /sys missing ..."
125     echo -e ${COLYELLOW}"Please create the directory /sys (mkdir -p /sys)."
126     echo -e ${COLYELLOW}"It's essential for a 2.6 kernel."
127     fi
128     fi
129    
130     ## load devfs ##
131 niro 150 # load devfs only with a 2.4 kernel or its really wanted with a 2.6
132     if [[ $(kernel_major_version) = 2.4 ]] || [[ ${RC_USED_DEV} = devfs ]]
133 niro 2 then
134     # start devfsd daemon, needed for bootsplash;
135     # no use of '/etc/rc.d/init.d/devfs' anymore
136     # check if devfs was mounted by the kernel,
137     # if not mount it (mbuild_livecd needs this one)
138     if [ ! -e /dev/.devfsd ]
139     then
140     echo -e ${COLOREDSTAR}"Mounting devfs file system ..."
141 niro 150 mount -n -t devfs devfs /dev
142 niro 2 evaluate_retval
143     fi
144    
145     if [ -e /dev/.devfsd ]
146     then
147     echo -e ${COLOREDSTAR}"Starting devfsd ..."
148     ## directory /lib/dev-state !must! exists ##
149     /sbin/devfsd /dev &> /dev/null
150     evaluate_retval
151     else
152     echo -e ${COLRED}"No devfs filesystem found ..."
153     echo -e ${COLYELLOW}"Your Kernel doesn't support the devfs filesystem."
154     echo -e ${COLYELLOW}"Devfs is necessary to run Magellan-Linux."
155     echo -e ${COLYELLOW}"Please make shure that this is enabled in your kernel."
156     echo
157     echo -e ${COLYELLOW}"Press any key to shutdown the system safely ..."
158     read
159     $rc_base/init.d/halt
160     fi
161     fi
162    
163     #### load udev ####
164 niro 150 # load udev only with a 2.6 kernel
165     if [[ $(kernel_major_version) = 2.6 ]] && [[ ${RC_USED_DEV} = udev ]]
166 niro 2 then
167 niro 428 # check if /dev/console exists outside tmpfs
168     [ -c /dev/console ] ; need_redirect=$?
169    
170 niro 150 # create a ramdisk for populating udev
171     echo -e ${COLOREDSTAR}"Mounting udev at /dev ..."
172 niro 394 # many video drivers needed exec access
173     fstype=ramfs
174 niro 150 # tmpfs was suggested by Greg Kroah-Hartman
175 niro 395 kernel_supports_fs tmpfs && fstype=tmpfs
176 niro 394 mount -n -t ${fstype} udev /dev -o exec,nosuid,mode=0755
177 niro 2 evaluate_retval
178    
179 niro 150 # if a device tarball exists load it and if it is activated
180 niro 2 echo -e ${COLOREDSTAR}"Configurating system to use udev ..."
181 niro 150 if [[ ${RC_DEVICE_TARBALL} = yes ]]
182 niro 2 then
183 niro 318 echo -e ${COLOREDSTAR}" Populating /dev with saved device nodes ..."
184 niro 2 tar -jxpf /lib/udev-state/devices.tar.bz2 -C /dev
185     evaluate_retval
186     fi
187    
188 niro 318 # other eeded device nodes with udev
189     seed_dev
190 niro 2
191 niro 318 if [ -e /proc/sys/kernel/hotplug ]
192 niro 2 then
193 niro 376 if [ "$(kernel_version | sed 's:\.::g' | cut -d_ -f1)" -gt "2614" ]
194 niro 318 then
195     echo -e ${COLOREDSTAR}" Using netlink for hotplug events ..."
196     echo "" > /proc/sys/kernel/hotplug
197     evaluate_retval
198 niro 394 else
199 niro 318 echo -e ${COLOREDSTAR}" Setting /sbin/udevsend as hotplug agent ..."
200     echo "/sbin/udevsend" > /proc/sys/kernel/hotplug
201     evaluate_retval
202     fi
203 niro 2 else
204     echo -e ${COLOREDSTAR}${COLYELLOW}" Kernel was not compiled with hotplug support !"
205 niro 318 print_status failure
206 niro 2 fi
207 niro 318
208     echo -e ${COLOREDSTAR}" Starting udevd daemon ..."
209 niro 428 if [ ${need_redirect} -eq 1 ]
210     then
211     # we need to open fds 0 1 2
212     /sbin/udevd --daemon </dev/console >/dev/console 2>/dev/console
213     else
214     /sbin/udevd --daemon
215     fi
216 niro 2 evaluate_retval
217 niro 318
218     populate_udev
219    
220     # create nodes that udev can't
221     echo -e ${COLOREDSTAR}" Finializing udev configuration ..."
222     [[ -x /sbin/dmsetup ]] && /sbin/dmsetup mknodes &>/dev/null
223     [[ -x /sbin/lvm ]] && /sbin/lvm vgscan -P --mknodes --ignorelockingfailure &>/dev/null
224     [[ -x /sbin/evms_activate ]] && /sbin/evms_activate -q &>/dev/null
225     print_status success
226    
227     # same thing as /dev/.devfsd
228     touch /dev/.udev
229 niro 2 fi
230    
231     ## load devpts ##
232     # devfs/udev with 2.6 has no ptys, so devpts is also needed
233 niro 150 if [[ $(kernel_major_version) = 2.6 ]]
234 niro 2 then
235     # check if we really have devpts support
236 niro 150 if kernel_supports_fs devpts
237 niro 2 then
238     # /dev/pts maybe not exists.
239     # We only create this directory only if devfs was mounted,
240     # or it will fail as / is still mounted readonly
241 niro 150 # udev has this dir already, only a sanity check for devfs
242     if [ ! -d "/dev/pts" -a -e "/dev/.devfsd" ] && is_fs_mounted devfs
243 niro 2 then
244     mkdir -p /dev/pts &> /dev/null || \
245     echo "Could not create /dev/pts !"
246     fi
247 niro 71
248 niro 150 # now mount devpts
249 niro 2 if [ -d /dev/pts ]
250     then
251     echo -e ${COLOREDSTAR}"Mounting devpts at /dev/pts ..."
252 niro 150 mount -n -t devpts -o gid=4,mode=0620 devpts /dev/pts
253 niro 2 evaluate_retval
254     fi
255     else
256     # devpts is not supported, give a warning
257     echo -e ${COLRED}"No devpts filesystem found ..."
258     echo -e ${COLYELLOW}"Your Kernel doesn't support the devpts filesystem."
259     echo -e ${COLYELLOW}"Devfs with a kernel-2.6.x needs devpts,"
260     echo -e ${COLYELLOW}"or no pty's are available."
261     echo -e ${COLYELLOW}"Please make shure that this is enabled in your kernel."
262     echo
263     echo -e ${COLYELLOW}"Press any key to continue ..."
264     read
265     fi
266     fi
267    
268     ### services state dir ###
269     echo -e ${COLOREDSTAR}"Mounting tmpfs at ${svcdir} ..."
270     mount -n -t tmpfs tmpfs "${svcdir}" -o rw,mode=0644,size="${svcsize}"k
271     evaluate_retval
272    
273 niro 150 # load bootsplash
274 niro 2 splash "rc_init" "${runlevel}"
275     fi
276    
277    
278 niro 150 if [[ $runlevel = 0 ]] || [[ $runlevel = 6 ]]
279 niro 2 then
280 niro 150 # load bootsplash
281 niro 2 splash "rc_init" "${runlevel}"
282    
283     # if requested save devices to a device tarball before halt
284     # only for kernels >=2.6 *and* udev
285     # make shure that udev is mounted but *not* devfs --> /dev/.devfsd
286 niro 150 if [[ ${RC_DEVICE_TARBALL} = yes ]] && \
287     [ -e /dev/.udev -a ! -e /dev/.devfsd -a ! -e /.bootdev ]
288 niro 2 then
289     echo -e ${COLOREDSTAR}"Saving /dev device nodes ..."
290 niro 150 ( cd /dev; tar -jclpf "/tmp/devices-$$.tar.bz2" * &> /dev/null )
291 niro 2 mv -f "/tmp/devices-$$.tar.bz2" /lib/udev-state/devices.tar.bz2
292     evaluate_retval
293     fi
294     fi
295    
296    
297     if [ "$runlevel" = "" ]
298     then
299     echo "Usage: $0 <runlevel>" >&2
300     exit 1
301     fi
302    
303 niro 150
304 niro 2 previous=$PREVLEVEL
305     [ "$previous" = "" ] && previous=N
306    
307     if [ ! -d $rc_base/rc$runlevel.d ]
308     then
309     echo "$rc_base/rc$runlevel.d does not exist"
310     exit 1
311     fi
312    
313     if [ "$previous" != "N" ]
314     then
315     for i in $(ls -v $rc_base/rc$runlevel.d/K* 2> /dev/null)
316     do
317    
318     check_script_status
319    
320     suffix=${i#$rc_base/rc$runlevel.d/K[0-9][0-9]}
321     prev_start=$rc_base/rc$previous.d/S[0-9][0-9]$suffix
322     sysinit_start=$rc_base/rcsysinit.d/S[0-9][0-9]$suffix
323    
324     if [ "$runlevel" != "0" ] && [ "$runlevel" != "6" ]
325     then
326     if [ ! -f $prev_start ] && [ ! -f $sysinit_start ]
327     then
328     $WARNING
329     echo "$i can't be executed because it was"
330     echo "not started in the previous runlevel ($previous)"
331     $NORMAL
332     continue
333     fi
334     fi
335    
336     $i stop
337     error_value=$?
338    
339     if [ "$error_value" != "0" ]
340     then
341     print_error_msg
342     fi
343     done
344     fi
345    
346     for i in $( ls -v $rc_base/rc$runlevel.d/S* 2> /dev/null)
347     do
348     if [ "$previous" != "N" ]
349     then
350     suffix=${i#$rc_base/rc$runlevel.d/S[0-9][0-9]}
351     stop=$rc_base/rc$runlevel.d/K[0-9][0-9]$suffix
352     prev_start=$rc_base/rc$previous.d/S[0-9][0-9]$suffix
353    
354     [ -f $prev_start ] && [ ! -f $stop ] && continue
355     fi
356    
357     check_script_status
358    
359     $i start
360     error_value=$?
361    
362     if [ "$error_value" != "0" ]
363     then
364     print_error_msg
365     fi
366     done

Properties

Name Value
svn:executable *